/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-04-09 19:13:20 UTC)
 * on 2013-04-12 at 11:05:46 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.gan.model;

/**
 * An AdvertiserResource.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Affiliate Network API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Advertiser extends com.google.api.client.json.GenericJson {

  /**
   * True if the advertiser allows publisher created links, otherwise false.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean allowPublisherCreatedLinks;

  /**
   * Category that this advertiser belongs to. A valid list of categories can be found here:
   * http://www.google.com/support/affiliatenetwork/advertiser/bin/answer.py?hl=en=107581
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String category;

  /**
   * The longest possible length of a commission (how long the cookies on the customer's browser
   * last before they expire).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer commissionDuration;

  /**
   * Email that this advertiser would like publishers to contact them with.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String contactEmail;

  /**
   * Phone that this advertiser would like publishers to contact them with.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String contactPhone;

  /**
   * The default link id for this advertiser.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long defaultLinkId;

  /**
   * Description of the website the advertiser advertises from.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String description;

  /**
   * The sum of fees paid to publishers divided by the total number of clicks over the past three
   * months. This value should be multiplied by 100 at the time of display.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Money epcNinetyDayAverage;

  /**
   * The sum of fees paid to publishers divided by the total number of clicks over the past seven
   * days. This value should be multiplied by 100 at the time of display.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Money epcSevenDayAverage;

  /**
   * The ID of this advertiser.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long id;

  /**
   * The requested advertiser.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Advertiser item;

  /**
   * Date that this advertiser was approved as a Google Affiliate Network advertiser.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime joinDate;

  /**
   * The kind for an advertiser.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * URL to the logo this advertiser uses on the Google Affiliate Network.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String logoUrl;

  /**
   * List of merchant center ids for this advertiser
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.util.List<java.lang.Long> merchantCenterIds;

  /**
   * The name of this advertiser.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String name;

  /**
   * A rank based on commissions paid to publishers over the past 90 days. A number between 1 and 4
   * where 4 means the top quartile (most money paid) and 1 means the bottom quartile (least money
   * paid).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String payoutRank;

  /**
   * Allows advertisers to submit product listings to Google Product Search.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean productFeedsEnabled;

  /**
   * List of redirect URLs for this advertiser
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> redirectDomains;

  /**
   * URL of the website this advertiser advertises from.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String siteUrl;

  /**
   * The status of the requesting publisher's relationship this advertiser.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String status;

  /**
   * True if the advertiser allows publisher created links, otherwise false.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getAllowPublisherCreatedLinks() {
    return allowPublisherCreatedLinks;
  }

  /**
   * True if the advertiser allows publisher created links, otherwise false.
   * @param allowPublisherCreatedLinks allowPublisherCreatedLinks or {@code null} for none
   */
  public Advertiser setAllowPublisherCreatedLinks(java.lang.Boolean allowPublisherCreatedLinks) {
    this.allowPublisherCreatedLinks = allowPublisherCreatedLinks;
    return this;
  }

  /**
   * Category that this advertiser belongs to. A valid list of categories can be found here:
   * http://www.google.com/support/affiliatenetwork/advertiser/bin/answer.py?hl=en=107581
   * @return value or {@code null} for none
   */
  public java.lang.String getCategory() {
    return category;
  }

  /**
   * Category that this advertiser belongs to. A valid list of categories can be found here:
   * http://www.google.com/support/affiliatenetwork/advertiser/bin/answer.py?hl=en=107581
   * @param category category or {@code null} for none
   */
  public Advertiser setCategory(java.lang.String category) {
    this.category = category;
    return this;
  }

  /**
   * The longest possible length of a commission (how long the cookies on the customer's browser
   * last before they expire).
   * @return value or {@code null} for none
   */
  public java.lang.Integer getCommissionDuration() {
    return commissionDuration;
  }

  /**
   * The longest possible length of a commission (how long the cookies on the customer's browser
   * last before they expire).
   * @param commissionDuration commissionDuration or {@code null} for none
   */
  public Advertiser setCommissionDuration(java.lang.Integer commissionDuration) {
    this.commissionDuration = commissionDuration;
    return this;
  }

  /**
   * Email that this advertiser would like publishers to contact them with.
   * @return value or {@code null} for none
   */
  public java.lang.String getContactEmail() {
    return contactEmail;
  }

  /**
   * Email that this advertiser would like publishers to contact them with.
   * @param contactEmail contactEmail or {@code null} for none
   */
  public Advertiser setContactEmail(java.lang.String contactEmail) {
    this.contactEmail = contactEmail;
    return this;
  }

  /**
   * Phone that this advertiser would like publishers to contact them with.
   * @return value or {@code null} for none
   */
  public java.lang.String getContactPhone() {
    return contactPhone;
  }

  /**
   * Phone that this advertiser would like publishers to contact them with.
   * @param contactPhone contactPhone or {@code null} for none
   */
  public Advertiser setContactPhone(java.lang.String contactPhone) {
    this.contactPhone = contactPhone;
    return this;
  }

  /**
   * The default link id for this advertiser.
   * @return value or {@code null} for none
   */
  public java.lang.Long getDefaultLinkId() {
    return defaultLinkId;
  }

  /**
   * The default link id for this advertiser.
   * @param defaultLinkId defaultLinkId or {@code null} for none
   */
  public Advertiser setDefaultLinkId(java.lang.Long defaultLinkId) {
    this.defaultLinkId = defaultLinkId;
    return this;
  }

  /**
   * Description of the website the advertiser advertises from.
   * @return value or {@code null} for none
   */
  public java.lang.String getDescription() {
    return description;
  }

  /**
   * Description of the website the advertiser advertises from.
   * @param description description or {@code null} for none
   */
  public Advertiser setDescription(java.lang.String description) {
    this.description = description;
    return this;
  }

  /**
   * The sum of fees paid to publishers divided by the total number of clicks over the past three
   * months. This value should be multiplied by 100 at the time of display.
   * @return value or {@code null} for none
   */
  public Money getEpcNinetyDayAverage() {
    return epcNinetyDayAverage;
  }

  /**
   * The sum of fees paid to publishers divided by the total number of clicks over the past three
   * months. This value should be multiplied by 100 at the time of display.
   * @param epcNinetyDayAverage epcNinetyDayAverage or {@code null} for none
   */
  public Advertiser setEpcNinetyDayAverage(Money epcNinetyDayAverage) {
    this.epcNinetyDayAverage = epcNinetyDayAverage;
    return this;
  }

  /**
   * The sum of fees paid to publishers divided by the total number of clicks over the past seven
   * days. This value should be multiplied by 100 at the time of display.
   * @return value or {@code null} for none
   */
  public Money getEpcSevenDayAverage() {
    return epcSevenDayAverage;
  }

  /**
   * The sum of fees paid to publishers divided by the total number of clicks over the past seven
   * days. This value should be multiplied by 100 at the time of display.
   * @param epcSevenDayAverage epcSevenDayAverage or {@code null} for none
   */
  public Advertiser setEpcSevenDayAverage(Money epcSevenDayAverage) {
    this.epcSevenDayAverage = epcSevenDayAverage;
    return this;
  }

  /**
   * The ID of this advertiser.
   * @return value or {@code null} for none
   */
  public java.lang.Long getId() {
    return id;
  }

  /**
   * The ID of this advertiser.
   * @param id id or {@code null} for none
   */
  public Advertiser setId(java.lang.Long id) {
    this.id = id;
    return this;
  }

  /**
   * The requested advertiser.
   * @return value or {@code null} for none
   */
  public Advertiser getItem() {
    return item;
  }

  /**
   * The requested advertiser.
   * @param item item or {@code null} for none
   */
  public Advertiser setItem(Advertiser item) {
    this.item = item;
    return this;
  }

  /**
   * Date that this advertiser was approved as a Google Affiliate Network advertiser.
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getJoinDate() {
    return joinDate;
  }

  /**
   * Date that this advertiser was approved as a Google Affiliate Network advertiser.
   * @param joinDate joinDate or {@code null} for none
   */
  public Advertiser setJoinDate(com.google.api.client.util.DateTime joinDate) {
    this.joinDate = joinDate;
    return this;
  }

  /**
   * The kind for an advertiser.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * The kind for an advertiser.
   * @param kind kind or {@code null} for none
   */
  public Advertiser setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * URL to the logo this advertiser uses on the Google Affiliate Network.
   * @return value or {@code null} for none
   */
  public java.lang.String getLogoUrl() {
    return logoUrl;
  }

  /**
   * URL to the logo this advertiser uses on the Google Affiliate Network.
   * @param logoUrl logoUrl or {@code null} for none
   */
  public Advertiser setLogoUrl(java.lang.String logoUrl) {
    this.logoUrl = logoUrl;
    return this;
  }

  /**
   * List of merchant center ids for this advertiser
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.Long> getMerchantCenterIds() {
    return merchantCenterIds;
  }

  /**
   * List of merchant center ids for this advertiser
   * @param merchantCenterIds merchantCenterIds or {@code null} for none
   */
  public Advertiser setMerchantCenterIds(java.util.List<java.lang.Long> merchantCenterIds) {
    this.merchantCenterIds = merchantCenterIds;
    return this;
  }

  /**
   * The name of this advertiser.
   * @return value or {@code null} for none
   */
  public java.lang.String getName() {
    return name;
  }

  /**
   * The name of this advertiser.
   * @param name name or {@code null} for none
   */
  public Advertiser setName(java.lang.String name) {
    this.name = name;
    return this;
  }

  /**
   * A rank based on commissions paid to publishers over the past 90 days. A number between 1 and 4
   * where 4 means the top quartile (most money paid) and 1 means the bottom quartile (least money
   * paid).
   * @return value or {@code null} for none
   */
  public java.lang.String getPayoutRank() {
    return payoutRank;
  }

  /**
   * A rank based on commissions paid to publishers over the past 90 days. A number between 1 and 4
   * where 4 means the top quartile (most money paid) and 1 means the bottom quartile (least money
   * paid).
   * @param payoutRank payoutRank or {@code null} for none
   */
  public Advertiser setPayoutRank(java.lang.String payoutRank) {
    this.payoutRank = payoutRank;
    return this;
  }

  /**
   * Allows advertisers to submit product listings to Google Product Search.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getProductFeedsEnabled() {
    return productFeedsEnabled;
  }

  /**
   * Allows advertisers to submit product listings to Google Product Search.
   * @param productFeedsEnabled productFeedsEnabled or {@code null} for none
   */
  public Advertiser setProductFeedsEnabled(java.lang.Boolean productFeedsEnabled) {
    this.productFeedsEnabled = productFeedsEnabled;
    return this;
  }

  /**
   * List of redirect URLs for this advertiser
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getRedirectDomains() {
    return redirectDomains;
  }

  /**
   * List of redirect URLs for this advertiser
   * @param redirectDomains redirectDomains or {@code null} for none
   */
  public Advertiser setRedirectDomains(java.util.List<java.lang.String> redirectDomains) {
    this.redirectDomains = redirectDomains;
    return this;
  }

  /**
   * URL of the website this advertiser advertises from.
   * @return value or {@code null} for none
   */
  public java.lang.String getSiteUrl() {
    return siteUrl;
  }

  /**
   * URL of the website this advertiser advertises from.
   * @param siteUrl siteUrl or {@code null} for none
   */
  public Advertiser setSiteUrl(java.lang.String siteUrl) {
    this.siteUrl = siteUrl;
    return this;
  }

  /**
   * The status of the requesting publisher's relationship this advertiser.
   * @return value or {@code null} for none
   */
  public java.lang.String getStatus() {
    return status;
  }

  /**
   * The status of the requesting publisher's relationship this advertiser.
   * @param status status or {@code null} for none
   */
  public Advertiser setStatus(java.lang.String status) {
    this.status = status;
    return this;
  }

  @Override
  public Advertiser set(String fieldName, Object value) {
    return (Advertiser) super.set(fieldName, value);
  }

  @Override
  public Advertiser clone() {
    return (Advertiser) super.clone();
  }

}
