/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-04-09 19:13:20 UTC)
 * on 2013-04-12 at 11:05:46 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.gan.model;

/**
 * A PublisherResource.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Affiliate Network API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Publisher extends com.google.api.client.json.GenericJson {

  /**
   * Classification that this publisher belongs to. See this link for all publisher classifications:
   * http://www.google.com/support/affiliatenetwork/advertiser/bin/answer.py?hl=en=107625=cb=cb=-k5f
   * ihzthfaik=4
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String classification;

  /**
   * The sum of fees paid to this publisher divided by the total number of clicks over the past
   * three months. Values are multiplied by 100 for display purposes.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Money epcNinetyDayAverage;

  /**
   * The sum of fees paid to this publisher divided by the total number of clicks over the past
   * seven days. Values are multiplied by 100 for display purposes.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Money epcSevenDayAverage;

  /**
   * The ID of this publisher.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long id;

  /**
   * The requested publisher.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Publisher item;

  /**
   * Date that this publisher was approved as a Google Affiliate Network publisher.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime joinDate;

  /**
   * The kind for a publisher.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The name of this publisher.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String name;

  /**
   * A rank based on commissions paid to this publisher over the past 90 days. A number between 1
   * and 4 where 4 means the top quartile (most money paid) and 1 means the bottom quartile (least
   * money paid).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String payoutRank;

  /**
   * Websites that this publisher uses to advertise.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> sites;

  /**
   * The status of the requesting advertiser's relationship with this publisher.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String status;

  /**
   * Classification that this publisher belongs to. See this link for all publisher classifications:
   * http://www.google.com/support/affiliatenetwork/advertiser/bin/answer.py?hl=en=107625=cb=cb=-k5f
   * ihzthfaik=4
   * @return value or {@code null} for none
   */
  public java.lang.String getClassification() {
    return classification;
  }

  /**
   * Classification that this publisher belongs to. See this link for all publisher classifications:
   * http://www.google.com/support/affiliatenetwork/advertiser/bin/answer.py?hl=en=107625=cb=cb=-k5f
   * ihzthfaik=4
   * @param classification classification or {@code null} for none
   */
  public Publisher setClassification(java.lang.String classification) {
    this.classification = classification;
    return this;
  }

  /**
   * The sum of fees paid to this publisher divided by the total number of clicks over the past
   * three months. Values are multiplied by 100 for display purposes.
   * @return value or {@code null} for none
   */
  public Money getEpcNinetyDayAverage() {
    return epcNinetyDayAverage;
  }

  /**
   * The sum of fees paid to this publisher divided by the total number of clicks over the past
   * three months. Values are multiplied by 100 for display purposes.
   * @param epcNinetyDayAverage epcNinetyDayAverage or {@code null} for none
   */
  public Publisher setEpcNinetyDayAverage(Money epcNinetyDayAverage) {
    this.epcNinetyDayAverage = epcNinetyDayAverage;
    return this;
  }

  /**
   * The sum of fees paid to this publisher divided by the total number of clicks over the past
   * seven days. Values are multiplied by 100 for display purposes.
   * @return value or {@code null} for none
   */
  public Money getEpcSevenDayAverage() {
    return epcSevenDayAverage;
  }

  /**
   * The sum of fees paid to this publisher divided by the total number of clicks over the past
   * seven days. Values are multiplied by 100 for display purposes.
   * @param epcSevenDayAverage epcSevenDayAverage or {@code null} for none
   */
  public Publisher setEpcSevenDayAverage(Money epcSevenDayAverage) {
    this.epcSevenDayAverage = epcSevenDayAverage;
    return this;
  }

  /**
   * The ID of this publisher.
   * @return value or {@code null} for none
   */
  public java.lang.Long getId() {
    return id;
  }

  /**
   * The ID of this publisher.
   * @param id id or {@code null} for none
   */
  public Publisher setId(java.lang.Long id) {
    this.id = id;
    return this;
  }

  /**
   * The requested publisher.
   * @return value or {@code null} for none
   */
  public Publisher getItem() {
    return item;
  }

  /**
   * The requested publisher.
   * @param item item or {@code null} for none
   */
  public Publisher setItem(Publisher item) {
    this.item = item;
    return this;
  }

  /**
   * Date that this publisher was approved as a Google Affiliate Network publisher.
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getJoinDate() {
    return joinDate;
  }

  /**
   * Date that this publisher was approved as a Google Affiliate Network publisher.
   * @param joinDate joinDate or {@code null} for none
   */
  public Publisher setJoinDate(com.google.api.client.util.DateTime joinDate) {
    this.joinDate = joinDate;
    return this;
  }

  /**
   * The kind for a publisher.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * The kind for a publisher.
   * @param kind kind or {@code null} for none
   */
  public Publisher setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The name of this publisher.
   * @return value or {@code null} for none
   */
  public java.lang.String getName() {
    return name;
  }

  /**
   * The name of this publisher.
   * @param name name or {@code null} for none
   */
  public Publisher setName(java.lang.String name) {
    this.name = name;
    return this;
  }

  /**
   * A rank based on commissions paid to this publisher over the past 90 days. A number between 1
   * and 4 where 4 means the top quartile (most money paid) and 1 means the bottom quartile (least
   * money paid).
   * @return value or {@code null} for none
   */
  public java.lang.String getPayoutRank() {
    return payoutRank;
  }

  /**
   * A rank based on commissions paid to this publisher over the past 90 days. A number between 1
   * and 4 where 4 means the top quartile (most money paid) and 1 means the bottom quartile (least
   * money paid).
   * @param payoutRank payoutRank or {@code null} for none
   */
  public Publisher setPayoutRank(java.lang.String payoutRank) {
    this.payoutRank = payoutRank;
    return this;
  }

  /**
   * Websites that this publisher uses to advertise.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getSites() {
    return sites;
  }

  /**
   * Websites that this publisher uses to advertise.
   * @param sites sites or {@code null} for none
   */
  public Publisher setSites(java.util.List<java.lang.String> sites) {
    this.sites = sites;
    return this;
  }

  /**
   * The status of the requesting advertiser's relationship with this publisher.
   * @return value or {@code null} for none
   */
  public java.lang.String getStatus() {
    return status;
  }

  /**
   * The status of the requesting advertiser's relationship with this publisher.
   * @param status status or {@code null} for none
   */
  public Publisher setStatus(java.lang.String status) {
    this.status = status;
    return this;
  }

  @Override
  public Publisher set(String fieldName, Object value) {
    return (Publisher) super.set(fieldName, value);
  }

  @Override
  public Publisher clone() {
    return (Publisher) super.clone();
  }

}
